datablock AudioProfile(bKnifeFireSound)
{
   filename    = "./bknife_swing.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(bKnifeHitBrickSound)
{
   filename    = "./bknife_hitbrick.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(bKnifeHitPlayerSound)
{
   filename    = "./bknife_hitplayer.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(bKnifeUseSound)
{
   filename    = "./bknife_use.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock ParticleData(bKnifeExplosionParticle)
{
   dragCoefficient      = 2;
   gravityCoefficient   = 1.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   spinRandomMin = -90;
   spinRandomMax = 90;
   lifetimeMS           = 500;
   lifetimeVarianceMS   = 300;
   textureName          = "base/data/particles/chunk";
   colors[0]     = "0.9 0.7 0.7 0.9";
   colors[1]     = "0.9 0.9 0.9 0.0";
   sizes[0]      = 0.25;
   sizes[1]      = 0.1;
};

datablock ParticleEmitterData(bKnifeExplosionEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   ejectionVelocity = 4;
   velocityVariance = 0.5;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 60;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "bKnifeExplosionParticle";

   uiName = "Knife Hit";
};

datablock ExplosionData(bKnifeExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 500;

   particleEmitter = bKnifeExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "20.0 22.0 20.0";
   camShakeAmp = "0.4 0.4 0.4";
   camShakeDuration = 0.5;
   camShakeRadius = 6.0;

   // Dynamic light
   lightStartRadius = 3;
   lightEndRadius = 0;
   lightStartColor = "0.7 0.2 0.2";
   lightEndColor = "0 0 0";
};

AddDamageType("Knife",   '<bitmap:add-ons/Weapon_TF2ButterflyKnife/CI_knife> %1',    '%2 <bitmap:add-ons/Weapon_TF2ButterflyKnife/CI_knife> %1',0.75,1);
AddDamageType("KnifeStab",   '<bitmap:add-ons/Weapon_TF2ButterflyKnife/CI_backstab> %1',    '%2 <bitmap:add-ons/Weapon_TF2ButterflyKnife/CI_backstab> %1',0.75,1);
datablock ProjectileData(bKnifeProjectile)
{
   directDamage        = 25;
   directDamageType  = $DamageType::Knife;
   radiusDamageType  = $DamageType::Knife;
   explosion           = bKnifeExplosion;
   //particleEmitter     = as;

   muzzleVelocity      = 50;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 100;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 1.5;
   lightColor  = "0 0 0.5";

   uiName = "Knife Stab";
};

datablock ItemData(bKnifeItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = ($TF2Knife::AltModels ? "Add-Ons/Weapon_ButterflyKnife/bknife2.dts" : "./knife.dts");
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "TF2 Butterfly Knife";
	iconName = ($TF2Knife::AltModels ? "Add-Ons/Weapon_ButterflyKnife/knife" : "./icon_knife");
	doColorShift = true;
	colorShiftColor = ($TF2Knife::AltModels ? "0.400 0.196 0 1.000" : "0.3 0.3 0.3");

	 // Dynamic properties defined by the scripts
	image = bKnifeImage;
	canDrop = true;
};

datablock ShapeBaseImageData(bKnifeImage)
{
   // Basic Item properties
   shapeFile = ($TF2Knife::AltModels ? "Add-Ons/Weapon_ButterflyKnife/bknife2.dts" : "./knife.dts");
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0.1 0.05";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;
   
   eyeOffset = "";
   
   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";
   
   // Projectile && Ammo.
   item = bKnifeItem;
   ammo = " ";
   projectile = bKnifeProjectile;
   projectileType = Projectile;
   
   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;
   
   //casing = " ";
   doColorShift = true;
   colorShiftColor = ($TF2Knife::AltModels ? "0.400 0.196 0 1.000" : "0.3 0.3 0.3");
   
   raycastWeaponRange = 3;
   raycastWeaponTargets = $TypeMasks::FxBrickObjectType |	//Targets the weapon can hit: Raycasting Bricks
   				$TypeMasks::PlayerObjectType |	//AI/Players
   				$TypeMasks::StaticObjectType |	//Static Shapes
   				$TypeMasks::TerrainObjectType |	//Terrain
   				$TypeMasks::VehicleObjectType;	//Vehicles
   raycastExplosionProjectile = bKnifeProjectile;
   raycastExplosionSound = "";
   raycastExplosionPlayerSound = bKnifeHitPlayerSound;
   raycastExplosionBrickSound = bKnifeHitBrickSound;
   raycastDirectDamage = 25;
   raycastDirectDamageType = $DamageType::Knife;
   
   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]			= "Activate";
	stateTimeoutValue[0]		= 0.5;
	stateTransitionOnTimeout[0]	= "Ready";
	stateSound[0]			= bKnifeUseSound;
	stateSequence[0]		= "activate";
	
	stateName[1]			= "Ready";
	stateTransitionOnTriggerDown[1]	= "PreFireA";
	stateAllowImageChange[1]	= true;
	stateSequence[1]		= "ready";
	
	stateName[2]			= "PreFireA";
	stateScript[2]                  = "onPreFire";
	stateAllowImageChange[2]        = false;
	stateTimeoutValue[2]            = 0.1;
	stateTransitionOnTimeout[2]     = "PreFireB";
	stateSequence[2]		= "ready";
	
	stateName[3]			= "PreFireB";
	stateAllowImageChange[3]        = false;
	stateTransitionOnNoAmmo[3]	= "Fire";
	stateTransitionOnAmmo[3]	= "StabWait";

	stateName[4]			= "StabWait";
	stateAllowImageChange[4]        = false;
	stateTimeoutValue[4]            = 0.1;
	stateTransitionOnTimeout[4]     = "Fire";
	
	stateName[5]                    = "Fire";
	stateTransitionOnTimeout[5]     = "PostFire";
	stateTimeoutValue[5]            = 0.2;
	stateFire[5]                    = true;
	stateAllowImageChange[5]        = false;
	stateSequence[5]                = "Fire";
	stateScript[5]                  = "onFire";
	stateSound[5]			= bKnifeFireSound;
	stateWaitForTimeout[5]		= true;
	
	stateName[6]			= "PostFire";
	stateTransitionOnAmmo[6]	= "Activate";
	stateTransitionOnTimeout[6]	= "CheckFire";
	stateTimeoutValue[6]		= 0.3;
	stateAllowImageChange[6]        = false;
	stateScript[6]                  = "onPostFire";
	stateWaitForTimeout[6]		= true;
	
	stateName[7]			= "CheckFire";
	stateTransitionOnTriggerUp[7]	= "StopFire";
	stateTransitionOnTriggerDown[7]	= "PreFireA";
	
	stateName[8]                    = "StopFire";
	stateTransitionOnTimeout[8]     = "Ready";
	stateTimeoutValue[8]            = 0.2;
	stateAllowImageChange[8]        = false;
	stateWaitForTimeout[8]		= true;
	stateSequence[8]                = "StopFire";
	stateScript[8]                  = "onStopFire";
};

function bKnifeImage::onPreFire(%this, %obj, %slot)
{
	%range = %this.raycastWeaponRange*getWord(%obj.getScale(),2);
	%targets = %this.raycastWeaponTargets; //checking just $TypeMasks::PlayerObjectType means you failstab through bricks
	%start = %obj.getEyePoint();
	
	%fvec = %obj.getForwardVector();
	%fX = getWord(%fvec,0);
	%fY = getWord(%fvec,1);
	
	%evec = %obj.getEyeVector();
	%eX = getWord(%evec,0);
	%eY = getWord(%evec,1);
	%eZ = getWord(%evec,2);
	
	%eXY = mSqrt(%eX*%eX+%eY*%eY);
	
	%aimVec = %fX*%eXY SPC %fY*%eXY SPC %eZ; //SHOULD get the direction you're aiming in
	
	%end = vectorAdd(%start,vectorScale(%aimVec,%range));
	
	%ray = ContainerRayCast(%start, %end, %targets, %obj);
	
	%col = getWord(%ray,0);
	
	if(!isObject(%col))
	{
		//Skip backstab animation waiting and do normal attack
		%obj.setImageAmmo(0,0);
		%obj.playthread(2, armattack);
		return;
	}
	
	%pos = posFromRaycast(%ray);
	%normal = normalFromRaycast(%ray);
	
	if(isObject(%col.spawnBrick) && %col.spawnBrick.getGroup().client == %obj.client)
		%dmg = 1;
	
	if((miniGameCanDamage(%obj,%col) == 1 || %dmg) && %obj.getDamagePercent() < 1.0 && (%obj.getType() & $TypeMasks::PlayerObjectType) && (%col.getType() & $TypeMasks::PlayerObjectType))
	{
		%stab = (vectorDot(%obj.getForwardVector(),%col.getForwardVector()) > 0);
		
		if(%stab)
		{
			//You are in the stab radius, start the animation
			%obj.setImageAmmo(0,1);
			serverplay3d(bknifeFireSound,%obj.getHackPosition());
			%obj.playthread(2, rotCW);
		}
		else
		{
			//Skip backstab animation waiting and do normal attack
			%obj.setImageAmmo(0,0);
			%obj.playthread(2, armattack);
		}
	}
	else
	{
		//Skip backstab animation waiting and do normal attack
		%obj.setImageAmmo(0,0);
		%obj.playthread(2, armattack);
	}
}

function bKnifeImage::onFire(%this,%obj,%slot)
{
   if(%obj.getDamagePercent() < 1.0 && %obj.getImageAmmo(%slot))
   {
      %obj.playThread(2,spearThrow);
      serverplay3d(critFireSound,%obj.getHackPosition());
   }
   Parent::onFire(%this,%obj,%slot);
}

function bKnifeImage::onPostFire(%this,%obj,%slot)
{
   if(!%obj.getImageAmmo(%slot))
      %obj.playThread(2,root);
}

function bKnifeImage::onRaycastDamage(%this,%obj,%slot,%col,%pos,%normal,%shotVec,%crit)
{
   %damageType = $DamageType::Direct;
   if(%this.raycastDirectDamageType)
      %damageType = %this.raycastDirectDamageType;
   
   %scale = getWord(%obj.getScale(), 2);
   %directDamage = mClampF(%this.raycastDirectDamage, -100, 100) * %scale;

   if(%obj.getImageAmmo(0) && (vectorDot(%obj.getForwardVector(),%col.getForwardVector()) > 0))
   {
      %directDamage = getWord(%col.getScale(),2) * %col.dataBlock.maxDamage * 6;
      %damageType = $DamageType::KnifeStab;
      
      %colscale = getWord(%col.getScale(),2);
      %col.spawnExplosion(critProjectile,%colscale);
      if(isObject(%col.client))
         %col.client.play2d(critRecieveSound);
      
      if(isObject(%obj.client))
         %obj.client.play2d(critHitSound);
      
      %col.setVelocity(vectorAdd(%col.getVelocity(),vectorAdd(vectorScale(%obj.getForwardVector(),20),"0 0 10")));
   }
   
   %col.schedule(0,damage,%obj, %pos, %directDamage, %damageType);
}

function bKnifeImage::onStopFire(%this, %obj, %slot)
{	
	%obj.playthread(2, root);
}

//This is for when the projectile is spawned by events
function bKnifeProjectile::damage(%this,%obj,%col,%fade,%pos,%normal)
{
   if(%this.directDamage <= 0)
      return;

   %damageType = $DamageType::Direct;
   if(%this.DirectDamageType)
      %damageType = %this.DirectDamageType;

   %scale = getWord(%obj.getScale(), 2);
   %directDamage = mClampF(%this.directDamage, -100, 100) * %scale;

   if(%col.getType() & $TypeMasks::PlayerObjectType)
   {
      %fv = vectorNormalize(getWords(%obj.getVelocity(),0,1));
      %stab = (vectorDot(%fv,%col.getForwardVector()) > 0);
      
      if(%stab)
      {
         %scale = getWord(%col.getScale(), 2);
         %directDamage = %col.dataBlock.maxDamage * %scale * 6;
         %damageType = $DamageType::KnifeStab;
         
         %col.spawnExplosion(critProjectile,%scale);
         %col.addVelocity(vectorAdd(vectorScale(%obj.getForwardVector(),20),"0 0 10"));
         if(isObject(%col.client))
         {
            %col.client.play2d(critRecieveSound);
         }
      }
      %col.damage(%obj, %pos, %directDamage, %damageType);
   }
   else
   {
      %col.damage(%obj, %pos, %directDamage, %damageType);
   }	
}